VTK: vtkODBCDatabase Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Friends | List of all members
vtkODBCDatabase Class Reference

maintain an ODBC connection to a SQL database More...

`#include <vtkODBCDatabase.h>`

Inheritance diagram for vtkODBCDatabase:
[legend]
Collaboration diagram for vtkODBCDatabase:
[legend]

## Public Types
typedef vtkSQLDatabase | Superclass
Public Types inherited from vtkSQLDatabase
typedef vtkObject | Superclass
typedef vtkSQLDatabase *(* | CreateFunction) (const char *URL)
| Type for CreateFromURL callback. More...

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkODBCDatabase * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
bool | Open (const char *password) override
| Open a new connection to the database. More...
void | Close () override
| Close the connection to the database. More...
bool | IsOpen () override
| Return whether the database has an open connection. More...
vtkSQLQuery * | GetQueryInstance () override
| Return an empty query on this database. More...
const char * | GetLastErrorText () override
| Get the last error text from the database. More...
vtkStringArray * | GetTables () override
| Get the list of tables from the database. More...
vtkStringArray * | GetRecord (const char *table) override
| Get the list of fields for a particular table. More...
bool | IsSupported (int feature) override
| Return whether a feature is supported by the database. More...
virtual void | SetServerPort (int)
virtual void | SetHostName (const char *)
virtual void | SetUserName (const char *)
virtual void | SetDatabaseName (const char *)
virtual char * | GetDatabaseName ()
virtual void | SetPassword (const char *)
bool | HasError () override
| Did the last operation generate an error. More...
vtkStdString | GetURL () override
| Get the URL of the database. More...
vtkStdString | GetColumnSpecification (vtkSQLDatabaseSchema *schema, int tblHandle, int colHandle) override
| Return the SQL string with the syntax to create a column inside a "CREATE TABLE" SQL statement. More...
vtkStdString | GetIndexSpecification (vtkSQLDatabaseSchema *schema, int tblHandle, int idxHandle, bool &skipped) override
| Return the SQL string with the syntax to create an index inside a "CREATE TABLE" SQL statement. More...
bool | CreateDatabase (const char *dbName, bool dropExisting)
| Create a new database, optionally dropping any existing database of the same name. More...
bool | DropDatabase (const char *dbName)
| Drop a database if it exists. More...
bool | ParseURL (const char *url) override
| This will only handle URLs of the form odbc://[user@]datsourcename[:port]/[dbname]. More...
virtual void | SetDataSourceName (const char *)
| Set the data source name. More...
virtual char * | GetDataSourceName ()
| Set the data source name. More...
const char * | GetDatabaseType () override
| String representing database type (e.g. More...
Public Member Functions inherited from vtkSQLDatabase
vtkSQLDatabase * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | IsSupported (int vtkNotUsed(feature))
| Return whether a feature is supported by the database. More...
virtual vtkStdString | GetTablePreamble (bool)
| Return the SQL string with the syntax of the preamble following a "CREATE TABLE" SQL statement. More...
virtual vtkStdString | GetTriggerSpecification (vtkSQLDatabaseSchema *schema, int tblHandle, int trgHandle)
| Return the SQL string with the syntax to create a trigger using a "CREATE TRIGGER" SQL statement. More...
virtual bool | EffectSchema (vtkSQLDatabaseSchema *, bool dropIfExists=false)
| Effect a database schema. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkODBCDatabase * | SafeDownCast (vtkObjectBase *o)
static vtkODBCDatabase * | New ()
Static Public Member Functions inherited from vtkSQLDatabase
static vtkTypeBool | IsTypeOf (const char *type)
static vtkSQLDatabase * | SafeDownCast (vtkObjectBase *o)
static vtkSQLDatabase * | CreateFromURL (const char *URL)
| Create a the proper subclass given a URL. More...
static vtkInformationObjectBaseKey * | DATABASE ()
| Stores the database class pointer as an information key. More...
static void | RegisterCreateFromURLCallback (CreateFunction callback)
| Provides mechanism to register/unregister additional callbacks to create concrete subclasses of vtkSQLDatabase to handle different protocols. More...
static void | UnRegisterCreateFromURLCallback (CreateFunction callback)
| Provides mechanism to register/unregister additional callbacks to create concrete subclasses of vtkSQLDatabase to handle different protocols. More...
static void | UnRegisterAllCreateFromURLCallbacks ()
| Provides mechanism to register/unregister additional callbacks to create concrete subclasses of vtkSQLDatabase to handle different protocols. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkODBCDatabase ()
| ~vtkODBCDatabase () override
virtual void | SetLastErrorText (const char *)
Protected Member Functions inherited from vtkSQLDatabase
| vtkSQLDatabase ()
| ~vtkSQLDatabase () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Friends
class | vtkODBCQuery

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

maintain an ODBC connection to a SQL database

ODBC is a standard for connecting to an SQL database regardless of vendor or implementation. In order to make it work you need two separate pices of software: a driver manager and then a database-specific driver. On Windows, the driver manager is built into the OS. On Unix platforms, the open-source packages iODBC and unixODBC will do the job. Mac OS X has its own driver manager and can also use the open-source packages. Database-specific drivers must be obtained from the entity that makes the database(s) you use.

Unlike the other VTK database drivers, ODBC can read its parameters from a configuration file (odbc.ini). That file can define an entire set of connection parameters and give it a single name called a data source name (DSN). Writing and maintaining odbc.ini files is beyond the scope of this header file.

Warning
  The password supplied as an argument to the Open call will override whatever password is set (if any) in the DSN definition. To use the password from the DSN definition, pass in nullptr for the password argument.
  Also, vtkSQLDatabase::CreateFromURL() will only handle URLs of the following form for ODBC:
  odbc://[user@]datsourcename[:port]/[dbname]
  Anything more complicated than that needs to be set up manually.
  Finally, this class does not yet support the schema API present in the SQLite, MySQL and PostgreSQL drivers. Those functions will be added once the bare-bones driver has been successfully integrated into VTK.

See also
  vtkODBCQuery

Tests:
  vtkODBCDatabase (Tests)

Definition at line 69 of file vtkODBCDatabase.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkSQLDatabase vtkODBCDatabase::Superclass

Definition at line 75 of file vtkODBCDatabase.h.

## Constructor & Destructor Documentation

## ◆ vtkODBCDatabase()

vtkODBCDatabase::vtkODBCDatabase | ( |  | ) |
| protected

## ◆ ~vtkODBCDatabase()

vtkODBCDatabase::~vtkODBCDatabase | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkODBCDatabase::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkODBCDatabase::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkSQLDatabase.

## ◆ SafeDownCast()

static vtkODBCDatabase* vtkODBCDatabase::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkODBCDatabase::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkSQLDatabase.

## ◆ NewInstance()

vtkODBCDatabase* vtkODBCDatabase::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkODBCDatabase::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

## ◆ New()

static vtkODBCDatabase* vtkODBCDatabase::New | ( |  | ) |
| static

## ◆ Open()

bool vtkODBCDatabase::Open | ( | const char * | password | ) |
| overridevirtual

Open a new connection to the database.

You need to set the filename before calling this function. Returns true if the database was opened successfully; false otherwise.

Implements vtkSQLDatabase.

## ◆ Close()

void vtkODBCDatabase::Close | ( |  | ) |
| overridevirtual

Close the connection to the database.

Implements vtkSQLDatabase.

## ◆ IsOpen()

bool vtkODBCDatabase::IsOpen | ( |  | ) |
| overridevirtual

Return whether the database has an open connection.

Implements vtkSQLDatabase.

## ◆ GetQueryInstance()

vtkSQLQuery* vtkODBCDatabase::GetQueryInstance | ( |  | ) |
| overridevirtual

Return an empty query on this database.

Implements vtkSQLDatabase.

## ◆ GetLastErrorText()

const char* vtkODBCDatabase::GetLastErrorText | ( |  | ) |
| overridevirtual

Get the last error text from the database.

Implements vtkSQLDatabase.

## ◆ GetTables()

vtkStringArray* vtkODBCDatabase::GetTables | ( |  | ) |
| overridevirtual

Get the list of tables from the database.

Implements vtkSQLDatabase.

## ◆ GetRecord()

vtkStringArray* vtkODBCDatabase::GetRecord | ( | const char * | table | ) |
| overridevirtual

Get the list of fields for a particular table.

Implements vtkSQLDatabase.

## ◆ IsSupported()

bool vtkODBCDatabase::IsSupported | ( | int | feature | ) |
| override

Return whether a feature is supported by the database.

## ◆ SetDataSourceName()

virtual void vtkODBCDatabase::SetDataSourceName | ( | const char * |  | ) |
| virtual

Set the data source name.

For ODBC connections this will be something listed in odbc.ini. The location of that file varies wildly based on system, ODBC library, and installation. Good luck.

## ◆ GetDataSourceName()

virtual char* vtkODBCDatabase::GetDataSourceName | ( |  | ) |
| virtual

Set the data source name.

For ODBC connections this will be something listed in odbc.ini. The location of that file varies wildly based on system, ODBC library, and installation. Good luck.

## ◆ SetServerPort()

virtual void vtkODBCDatabase::SetServerPort | ( | int |  | ) |
| virtual

## ◆ SetHostName()

virtual void vtkODBCDatabase::SetHostName | ( | const char * |  | ) |
| virtual

## ◆ SetUserName()

virtual void vtkODBCDatabase::SetUserName | ( | const char * |  | ) |
| virtual

## ◆ SetDatabaseName()

virtual void vtkODBCDatabase::SetDatabaseName | ( | const char * |  | ) |
| virtual

## ◆ GetDatabaseName()

virtual char* vtkODBCDatabase::GetDatabaseName | ( |  | ) |
| virtual

## ◆ SetPassword()

virtual void vtkODBCDatabase::SetPassword | ( | const char * |  | ) |
| virtual

## ◆ HasError()

bool vtkODBCDatabase::HasError | ( |  | ) |
| overridevirtual

Did the last operation generate an error.

Implements vtkSQLDatabase.

## ◆ GetDatabaseType()

const char* vtkODBCDatabase::GetDatabaseType | ( |  | ) |
| inlineoverridevirtual

String representing database type (e.g.

"ODBC").

Implements vtkSQLDatabase.

Definition at line 144 of file vtkODBCDatabase.h.

## ◆ GetURL()

vtkStdString vtkODBCDatabase::GetURL | ( |  | ) |
| overridevirtual

Get the URL of the database.

Implements vtkSQLDatabase.

## ◆ GetColumnSpecification()

vtkStdString vtkODBCDatabase::GetColumnSpecification | ( | vtkSQLDatabaseSchema * | schema,
|  | int | tblHandle,
|  | int | colHandle
| ) |  |
| overridevirtual

Return the SQL string with the syntax to create a column inside a "CREATE TABLE" SQL statement.

NB2: if a column has type SERIAL in the schema, this will be turned into INT NOT nullptr. Therefore, one should not pass NOT nullptr as an attribute of a column whose type is SERIAL.

Reimplemented from vtkSQLDatabase.

## ◆ GetIndexSpecification()

vtkStdString vtkODBCDatabase::GetIndexSpecification | ( | vtkSQLDatabaseSchema * | schema,
|  | int | tblHandle,
|  | int | idxHandle,
|  | bool & | skipped
| ) |  |
| overridevirtual

Return the SQL string with the syntax to create an index inside a "CREATE TABLE" SQL statement.

Reimplemented from vtkSQLDatabase.

## ◆ CreateDatabase()

bool vtkODBCDatabase::CreateDatabase | ( | const char * | dbName,
|  | bool | dropExisting
| ) |  |

Create a new database, optionally dropping any existing database of the same name.

Returns true when the database is properly created and false on failure.

## ◆ DropDatabase()

bool vtkODBCDatabase::DropDatabase | ( | const char * | dbName | ) |

Drop a database if it exists.

Returns true on success and false on failure.

## ◆ ParseURL()

bool vtkODBCDatabase::ParseURL | ( | const char * | url | ) |
| overridevirtual

This will only handle URLs of the form odbc://[user@]datsourcename[:port]/[dbname].

Anything more complicated than that needs to be set up manually.

Implements vtkSQLDatabase.

## ◆ SetLastErrorText()

virtual void vtkODBCDatabase::SetLastErrorText | ( | const char * |  | ) |
| protectedvirtual

## Friends And Related Function Documentation

## ◆ vtkODBCQuery

friend class vtkODBCQuery
| friend

Definition at line 72 of file vtkODBCDatabase.h.

The documentation for this class was generated from the following file:

- IO/ODBC/vtkODBCDatabase.h